#!BPY

# A script to convert a NURBS Curve into a set of IPO curves which can be used by an object to simulate the path it is flying
# Original script by haramanai of Belnder Artists
# First imptovement by Dr S
# Second improvement by Grogyan with hacks of his own code

# This script should now work from the scripts menu

"""
Name: 'Path 2 IPO'
Blender: 248
Group: 'Wizards'
Tooltip: 'Make IPO curves from NURBS or Bezier curves'
"""

import Blender
from Blender import Ipo, Object

scn = Blender.Scene.GetCurrent()


#Bake the animation in a way.

# f1 is the start frame f2 is the end
# change them to suit your needs
f1 = 1

# Get the currently selected object
MyCurveOb = Blender.Object.GetSelected()[0]

# Get the data associated with it
myCurveData = Blender.Curve.Get()[0]

# Get the object name of the curve
myCurveName = MyCurveOb.getName()
#myCurveBez = Blender.Object.Get(myCurve)	# Get data of curve 
		
# Initialize what will be the name of the IPO's
myIPOCurveSet =  MyCurveOb.getName() 

# Get the length of the curve in frames
myPathLength = myCurveData.getPathLen()


#sets the number of frames per ipo keys
step = 1

#The duplicant
Blender.Object.Duplicate()
MyCurveOb2 = Blender.Object.GetSelected()[0]
MyCurveOb2.clrParent()
MyCurveOb2.clearIpo()

for i in range(f1, myPathLength, step):
	Blender.Set('curframe' , i)
	MyCurveOb2.setMatrix(MyCurveOb.getMatrix())
	MyCurveOb2.insertIpoKey(0)
	MyCurveOb2.insertIpoKey(1)
	
	print "Frame: %s of %s of Object being animated: %s" % (i, myPathLength, MyCurveOb.name)
	
MyCurveOb2.name = 'Zero_Surplurflous_Object'
myIPOCurveSet = MyCurveOb2.getIpo()
myIPOCurveSet.name = MyCurveOb.name

print "Generated Ipo's name: ", myIPOCurveSet.name

Blender.Set('curframe', 1)


MyCurveOb.setIpo(myIPOCurveSet)
MyCurveOb.clrParent()

myIPOCurveSpeed = myIPOCurveSet.addCurve('Time')
MyCurveOb2.setLocation (0, 0, 0)
MyCurveOb2 = MyCurveOb2.clearIpo ()


myIPOCurveSpeed.interpolation = 1


myIPOCurveSpeed.append((0, 0))
myIPOCurveSpeed.append((myPathLength, myPathLength / 10.0)) 	# The first variable is the length of the animation, 
																# the second is a variable preset to a smooth low speed 
											
			

											
